# PS2_2.py -- template for task #2
import PS2_tests

# These are the two 7-bit sync patterns, LSB first
sync1 = [0,0,1,1,1,1,1]
sync2 = [1,1,0,0,0,0,0]

def receive_8b10b(received_bits,packet_size=16):
    """
    Convert a sequence of bits transmitted by a 8b/10b encoder into a
    sequence of message bytes.  The received bit sequence is made up
    of 16-byte packets preceded by one of the two 8b10b SYNC
    sequences.  There may be other bits between packets (e.g., bits
    serving as a clock training sequence) -- these should be ignored
    by your function.
    """

    result = []
    index = 0
    l = len(received_bits)
    
    while index < l:
        #print index
        #look for sync
        nextstr = []
        for i in range(0,7,1):
            nextstr.append(received_bits[index+i])
        #print nextstr
        if nextstr != sync1 and nextstr != sync2:
            index = index+ 1
        else:
            index = index + 7
            #once we are in a packet
            #print 'new packet'
            
            words = 0
            while words <= 15:
                #check if packet ends early
                if (l-index) == 0:
                    break
                
                word = []
                for i in range(0,10,1):
                    word.append(received_bits[index+i])
                #print word
                #print PS2_tests.bits_to_int(word)
                #print PS2_tests.table_10b_8b[PS2_tests.bits_to_int(word)]
                if PS2_tests.table_10b_8b[PS2_tests.bits_to_int(word)] != None:
                    #print chr(PS2_tests.table_10b_8b[PS2_tests.bits_to_int(word)])
                    result.append(chr(PS2_tests.table_10b_8b[PS2_tests.bits_to_int(word)]))
                else:
                    #ignore
                    break
                
                #print result
                
                words = words+1
                index = index+10
    print len(received_bits)
    
    string = ""
    for i in result:
        string = string+i
    return string


# testing code.  Do it this way so we can import this file
# and use its functions without also running the test code.
if __name__ == '__main__':
    # short message is just the word "test"
    PS2_tests.task2_test(receive_8b10b,PS2_tests.short_message)

    # now try a longer message with multiple packets
    PS2_tests.task2_test(receive_8b10b,PS2_tests.long_message)
